package com.ejie.ab39a.control;

import com.ejie.ab39a.service.ElementosPgService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import com.ejie.ab39a.model.ElementosPg;

/**
 * ElementosPgController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/elementospg")

public class ElementosPgController {

	private static final Logger logger = LoggerFactory.getLogger(ElementosPgController.class);

	@Autowired
	private ElementosPgService elementosPgService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param codelempg
	 *            Integer codelempg
	 * @return ElementosPg Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{codelempg}", method = RequestMethod.GET)
	public @ResponseBody ElementosPg get(@PathVariable Integer codelempg) {
		ElementosPg elementosPg = new ElementosPg();
		elementosPg.setCodelempg(codelempg);
		elementosPg = this.elementosPgService.find(elementosPg);
		ElementosPgController.logger.info("[GET - findBy_PK] : Obtener ElementosPg por PK");
		return elementosPg;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterElementosPg
	 *            ElementosPg Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<ElementosPg> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<ElementosPg> getAll(@ModelAttribute ElementosPg filterElementosPg) {
		ElementosPgController.logger.info("[GET - find_ALL] : Obtener ElementosPg por filtro");
		return this.elementosPgService.findAll(filterElementosPg, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param elementosPg
	 *            ElementosPg Bean que contiene la informacion a modificar.
	 * @return ElementosPg Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody ElementosPg edit(@RequestBody ElementosPg elementosPg) {
		ElementosPg elementosPgAux = this.elementosPgService.update(elementosPg);
		ElementosPgController.logger.info("[PUT] : ElementosPg actualizado correctamente");
		return elementosPgAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param elementosPg
	 *            ElementosPg Bean que contiene la informacion con la que se va
	 *            a crear el nuevo registro.
	 * @return ElementosPg Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody ElementosPg add(@RequestBody ElementosPg elementosPg) {
		ElementosPg elementosPgAux = this.elementosPgService.add(elementosPg);
		ElementosPgController.logger.info("[POST] : ElementosPg insertado correctamente");
		return elementosPgAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param codelempg
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return ElementosPg Bean eliminado.
	 */
	@RequestMapping(value = "/{codelempg}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody ElementosPg remove(@PathVariable Integer codelempg) {
		ElementosPg elementosPg = new ElementosPg();
		elementosPg.setCodelempg(codelempg);
		this.elementosPgService.remove(elementosPg);
		ElementosPgController.logger.info("[DELETE] : ElementosPg borrado correctamente");
		return elementosPg;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit() {
		ElementosPgController.logger.info("[GET - View] : elementospg");
		return "elementospg";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterElementosPg
	 *            ElementosPg Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<ElementosPg> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<ElementosPg> filter(
			@RequestJsonBody(param = "filter") ElementosPg filterElementosPg,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ElementosPgController.logger.info("[POST - filter] : Obtener ElementosPgs");
		return this.elementosPgService.filter(filterElementosPg, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterElementosPg
	 *            ElementosPg Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") ElementosPg filterElementosPg,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ElementosPgController.logger
				.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples ElementosPgs");
		this.elementosPgService.removeMultiple(filterElementosPg, jqGridRequestDto, false);
		ElementosPgController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}
}
